package	jp.co.sds_corp.util.jmx.rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Set;

import javax.management.Attribute;
import javax.management.AttributeNotFoundException;
import javax.management.InstanceNotFoundException;
import javax.management.InvalidAttributeValueException;
import javax.management.MBeanException;
import javax.management.ObjectName;
import javax.management.QueryExp;
import javax.management.ReflectionException;

public interface JMXAdaptor extends Remote
{
	public Object invoke(ObjectName name, String actionName, Object[] params,
						String[] signature)
		throws InstanceNotFoundException, MBeanException, ReflectionException,
				RemoteException;

	public Set queryMBeans(ObjectName name, QueryExp query)
		throws RemoteException;

	public Collection getMBeanInfos() throws RemoteException;

	public void setAttribute(ObjectName name, Attribute attribute)
		throws InstanceNotFoundException, AttributeNotFoundException,
				InvalidAttributeValueException, MBeanException,
				ReflectionException, RemoteException;

	public Object getAttribute(ObjectName name, String attribute)
		throws MBeanException, AttributeNotFoundException,
				InstanceNotFoundException, ReflectionException,
				RemoteException;
}
