package	jp.co.sds_corp.util.jmx.rmi.client;

import java.util.Hashtable;
import java.util.Iterator;

import javax.management.MBeanServer;
import javax.management.ObjectName;

import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.jmx.AbstractMBeanService;
import jp.co.sds_corp.util.jmx.rmi.JMXConnector;

public class ConnectorFactoryService extends AbstractMBeanService
	implements ConnectorFactoryServiceMBean
{
	private static final String		JNDI_NAME = "jp.co.sds_corp.util.jmx:connector:factory";
	private MBeanServer				mServer;
	private ConnectorFactoryImpl	mFactory;
	
	public ConnectorFactoryService() {
	}
	
	public Iterator getConnectors( Hashtable pProperties,
					ConnectorFactoryImpl.IConnectorTester pTester )
	{
		return mFactory.getConnectors( pProperties, pTester );
	}

	public JMXConnector createConnection( ConnectorFactoryImpl.ConnectorName pConnector ) {
		return mFactory.createConnection( pConnector );
	}

	public void removeConnection( ConnectorFactoryImpl.ConnectorName pConnector ) {
		mFactory.removeConnection( pConnector );
	}

	public ObjectName getObjectName( MBeanServer pServer, ObjectName pName )
		throws javax.management.MalformedObjectNameException
	{
		mServer = pServer;
		System.out.println( "ConnectorFactoryService.getObjectName(), server: " + mServer +
						", object name: " + OBJECT_NAME +
						", instance: " + new ObjectName( OBJECT_NAME ) );
		return new ObjectName( OBJECT_NAME );
	}

	public String getName() {
		return "JMX Client Connector Factory";
	}

	public void initService( IConfiguration config ) throws Exception {
		try {
			mFactory = new ConnectorFactoryImpl( mServer );
		} catch( Exception ex ) {
			ex.printStackTrace();
		}
	}

	public void startService() throws Exception {
		//new InitialContext().bind( JNDI_NAME, mFactory );
	}

	public void stopService() {
	}
}
